unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  SysUtils, Forms, Controls, StdCtrls,

  LazIpHlpApi;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnInfo: TButton;
    Memo1: TMemo;
    procedure btnInfoClick(Sender: TObject);
  private
    procedure RetrieveLocalAdapterInformation;
  public

  end;


var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.btnInfoClick(Sender: TObject);
var
  myArr: TAdapterInfosA;
  i: Integer;
begin
  memo1.Lines.Clear;

  myArr := GetAdapterInfos;

  for i := 0 to High(myArr) do
  begin
    memo1.Lines.Add('Description: '    + myArr[i].Description);
    memo1.Lines.Add('MAC address: '    + myArr[i].MacAddress);
    memo1.Lines.Add('IP address: '     + myArr[i].IpAddress);
    memo1.Lines.Add('IP subnet mask: ' + myArr[i].SubNetMask);
    memo1.Lines.Add('Gateway: '        + myArr[i].Gateway);
    memo1.Lines.Add('DHCP: '           + myArr[i].DHCPServer);
    memo1.Lines.Add('Broadcast: '      + myArr[i].Broadcast);
    memo1.Lines.Add('DNS: '            + myArr[i].DNSServer);
    memo1.Lines.Add('');
  end;

end;

procedure TForm1.RetrieveLocalAdapterInformation;
{
var
  pAdapterInfo: PIP_ADAPTER_INFO;
  AdapterInfo: IP_ADAPTER_INFO;
  BufLen: DWORD;
  Status: DWORD;
  strMAC: String;
  i: Integer;
  }
begin
  {
  // Adapter IP Infos
  BufLen := SizeOf(AdapterInfo);
  pAdapterInfo := @AdapterInfo;
  Status := GetAdaptersInfo(nil, @BufLen);
  pAdapterInfo := AllocMem(BufLen);

  try
    // IP Infos
    Status := GetAdaptersInfo(pAdapterInfo, @BufLen);
    if (Status <> ERROR_SUCCESS) then
    begin
      Dispose(pAdapterInfo);
      Exit;
    end;

    while (pAdapterInfo <> nil) do
    begin
      memo1.Lines.Add('');
      memo1.Lines.Add('Index: ' + pAdapterInfo^.Index.ToString);
      memo1.Lines.Add('ComboIndex: ' + pAdapterInfo^.ComboIndex.ToString);
      memo1.Lines.Add('Description: ' + pAdapterInfo^.Description);
      memo1.Lines.Add('Name: ' + pAdapterInfo^.AdapterName);

      strMAC := '';
      for i := 0 to pAdapterInfo^.AddressLength - 1 do
        strMAC := strMAC + '-' + IntToHex(pAdapterInfo^.Address[i], 2);

      Delete(strMAC, 1, 1);
      memo1.Lines.Add('MAC address: '    + strMAC);
      memo1.Lines.Add('IP address: '     + pAdapterInfo^.IpAddressList.IpAddress.ToString);
      memo1.Lines.Add('IP subnet mask: ' + pAdapterInfo^.IpAddressList.IpMask.ToString);
      memo1.Lines.Add('Gateway: '        + pAdapterInfo^.GatewayList.IpAddress.ToString);
      memo1.Lines.Add('DHCP enabled: '   + pAdapterInfo^.DhcpEnabled.ToString);
      memo1.Lines.Add('DHCP: '           + pAdapterInfo^.DhcpServer.IpAddress.ToString);
      memo1.Lines.Add('Have WINS: '      + pAdapterInfo^.HaveWins.ToString(True));
      memo1.Lines.Add('Primary WINS: '   + pAdapterInfo^.PrimaryWinsServer.IpAddress.ToString);
      memo1.Lines.Add('Secondary WINS: ' + pAdapterInfo^.SecondaryWinsServer.IpAddress.ToString);

      pAdapterInfo := pAdapterInfo^.Next;
    end;

  finally
    Dispose(pAdapterInfo);
  end;
  }
end;

end.

